function igualablanco

%(Cfondo,C)El test mide 3 cm y se ha de presentar a 86 cm

%temporizador
global temporizador datos
%dominio espacial de la imagen
N=120;
ang=2;
x=linspace(-ang/2,ang/2,N);
y=linspace(ang/2,-ang/2,N);
[x,y]=meshgrid(x,y);
[th,r]=cart2pol(x,y);
%imagen indexada
datos.im=((r<ang/2)& (x<=0))+2*((r<ang/2)& (x>0))+1;
%figure;imshow(im,[0 0 0;1 1 1;1 1 0]);

%paletas de colores, CIEXYZ
datos.Cblanco=[20 20 20];
datos.Cfondo=[28.4738 20 8.4738];

datos.C=[24.2267 20 8.1101;20.6146 20 7.7992;17.5063 20 7.5317;14.8031 20 7.2990;12.4148 20 7.0949];
datos.tC=tri2coor(datos.C,[0 1 0]);

%[T_l,Yw,Msx]=loadsysm('ciexyz.mat');
%figure;colordgm([datos.Cblanco;datos.Cfondo;datos.C],1,T_l,Yw,'show_numb',1)

%paletas de colores, DAC
datos.Yw=[0 1 0];
%
[datos.tm,datos.a,datos.g]=loadmonm('std_crt.mat',eye(3)); %monitor de clase con el ajuste de n que pasa por 0

%[datos.tm,datos.a,datos.g]=loadmonm('monitorGOG.mat',eye(3)) %monitor del
%portatil con el ajuste de n que pasa por 0. MAL ELECCIN COLORES

%datos.mon=load('monitorICC.mat')monitor del portatil con ajuste que no pasa por 0 para n


datos.nblanco=tri2val(datos.Cblanco,datos.Yw,datos.tm,datos.a,datos.g,8);
%Para el monitor ICC
%datos.nblanco=xyz2dac(datos.Cblanco,datos.mon.primarios,datos.mon.ruido,datos.mon.parametros,datos.mon.tipo_ajuste,8)

datos.nfondo=tri2val(datos.Cfondo,datos.Yw,datos.tm,datos.a,datos.g,8);
%Para el monitor ICC
%datos.nfondo=xyz2dac(datos.Cfondo,datos.mon.primarios,datos.mon.ruido,datos.mon.parametros,datos.mon.tipo_ajuste,8)


datos.n=tri2val(datos.C,datos.Yw,datos.tm,datos.a,datos.g,8);
%Para el monitor ICC
%datos.n=xyz2dac(datos.C,datos.mon.primarios,datos.mon.ruido,datos.mon.parametros,datos.mon.tipo_ajuste,8)


%cambios de luminancia
datos.Ymax=40;
datos.DY=0.5;   %incremento de luminancia

datos.parar=0;
datos.quecol=3;
datos.pal=[datos.nblanco;datos.nfondo;datos.n(datos.quecol,:)];
p=get(0,'ScreenSize');
figure;set(gcf,'color',datos.nblanco,'units','pixels','position',get(0,'ScreenSize'))
set(gca,'units','pixels','position',round([(p(3)-N)/2 (p(4)-N)/2 N N]))
imshow(datos.im,datos.pal,'initialmagnification','fit');
handles.datos=datos;
handles.historia=[];
guidata(gcf,handles);
set(gcf,'WindowKeyPressFcn',@teclasiguala)
pausacolor


function teclasiguala(hobject,aa)
global temporizador datos
    load teclasb.mat
    handles=guidata(hobject);
    datos=handles.datos;
    historia=handles.historia;
    teclas{3}='s';teclas{4}='n';
    tc=get(gcf,'CurrentCharacter');
    kk=strfind(teclas,tc);
    que=find(~cellfun(@isempty,kk));
    if isempty(que) que=-2;end
    
    switch que
        case 1
            datos.tC(datos.quecol,3)=datos.tC(datos.quecol,3)+datos.DY;
            if datos.tC(datos.quecol,3)>datos.Ymax
               datos.tC(datos.quecol,3)=datos.Ymax;
            end
            datos.C=coor2tri(datos.tC,datos.Yw);
            datos.pal(3,:)=tri2val(datos.C(datos.quecol,:),datos.Yw,datos.tm,datos.a,datos.g,8,0);
            %Para el monitor ICC
            %datos.pal(3,:)=xyz2dac(datos.C(datos.quecol,:),datos.mon.primarios,datos.mon.ruido,datos.mon.parametros,datos.mon.tipo_ajuste,8)
            imshow(datos.im,datos.pal,'initialmagnification','fit');
           % title(mat2str(datos.C(datos.quecol,:)))
        case 2
            datos.tC(datos.quecol,3)=datos.tC(datos.quecol,3)-datos.DY;
            if datos.tC(datos.quecol,3)<0
               datos.tC(datos.quecol,3)=0;
            end
            datos.C=coor2tri(datos.tC,datos.Yw);
            datos.pal(3,:)=tri2val(datos.C(datos.quecol,:),datos.Yw,datos.tm,datos.a,datos.g,8,0);
            %Para el monitor ICC
            %datos.pal(3,:)=xyz2dac(datos.C(datos.quecol,:),datos.mon.primarios,datos.mon.ruido,datos.mon.parametros,datos.mon.tipo_ajuste,8)
            imshow(datos.im,datos.pal,'initialmagnification','fit');
            %title(mat2str(datos.C(datos.quecol,:)))
            
        case 3
            historia=[historia;datos.quecol 1];
            if historia(end,1)>=3 & historia(end,1)<5
                datos.quecol=datos.quecol+1;
                datos.pal(3,:)=datos.n(datos.quecol,:);
                imshow(datos.im,datos.pal,'initialmagnification','fit');
            
            else
                datos.parar=1;
                datos.quecol=-1;
            end
            
            %title(mat2str(datos.quecol)) 
            
        case 4
            historia=[historia;datos.quecol 0];
            
            if historia(end,1)<=3 & historia(end,1)>1
                datos.quecol=datos.quecol-1;
                datos.pal(3,:)=datos.n(datos.quecol,:);
                imshow(datos.im,datos.pal,'initialmagnification','fit');
            else
                datos.parar=1;
                datos.quecol=-1;
            end
            %title(mat2str(datos.quecol)) 
    end
        
    if datos.parar==1
        %historia
       ultimosi=find(historia(:,2),1,'last');
       if isempty(ultimosi)
          msgbox('Sujeto Normal','Diagnóstico')
       else
          msgbox(['Sujeto Grado ' num2str(historia(ultimosi,1))],'Diagnóstico')  
       end
       stop(temporizador)
       delete(temporizador)
    end
      handles.historia=historia;
      handles.datos=datos;
      guidata(hobject,handles)       
            
            
        
    
    
    


